unit hiEvents;

interface

uses
  Windows, Kol, Share, Debug;

type
  THIEvents = class(TDebug)
    private
      FEvent: THandle;
      procedure SetManualReset(Value: Boolean);
    public
      _prop_Name: string;
      property _prop_ManualReset: Boolean write SetManualReset; //        *.ini (!)
      
      destructor Destroy; override;

      procedure _work_doSet(var _Data: TData; Index: Word);
      procedure _work_doReset(var _Data: TData; Index: Word);
      procedure _var_ObjHandle(var _Data: TData; Index: Word);
  end;

implementation

destructor THIEvents.Destroy;
begin
  CloseHandle(FEvent);
  inherited;
end;

procedure THIEvents.SetManualReset(Value: Boolean);
begin
  if FEvent <> 0 then CloseHandle(FEvent);

  FEvent := CreateEvent(nil, Value, False, Pointer(_prop_Name));
end;

procedure THIEvents._work_doSet(var _Data: TData; Index: Word);
begin
  SetEvent(FEvent);
end;

procedure THIEvents._work_doReset(var _Data: TData; Index: Word);
begin
  ResetEvent(FEvent);
end;

procedure THIEvents._var_ObjHandle(var _Data: TData; Index: Word);
begin
  dtInteger(_Data, FEvent);
end;

end.
